﻿const menuItems = [
    { "id": "1", name: "Google(zh)", url: "http://lens.google.com/uploadbyurl?hl=zh&url=" },
    { "id": "2", name: "Google(en)", url: "http://lens.google.com/uploadbyurl?hl=en&url=" },
    { "id": "3", name: "qidb", url: "http://iqdb.org/?url=" },
    { "id": "4", name: "SauceNAO", url: "http://saucenao.com/search.php?url=" },
    { "id": "5", name: "TinEye", url: "http://tineye.com/search?url=" },
];

const idToUrl = {};

chrome.runtime.onInstalled.addListener(function () {

    menuItems.forEach(p => {
        chrome.contextMenus.create({
            id: p.id, contexts: ["image"], title: `${p.id} 在 ${p.name} 搜索图片`
        })
        idToUrl[p.id] = p.url;
    })


});

chrome.contextMenus.onClicked.addListener((info, tab) => {
    var searchUrl = idToUrl[info.menuItemId] + info.srcUrl;


    chrome.tabs.sendMessage(tab.id, { type: 'getKeyboardState' }, (response) => {
        const { ctrl, shift } = response;

        if (shift) {
            // Shift+点击：在新窗口打开
            chrome.windows.create({ url: searchUrl, });
        } else {

            chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
                const currentTabIndex = tabs[0].index;

                if (ctrl) {
                    // Ctrl+点击：在后台打开
                    chrome.tabs.create({ url: searchUrl, active: false, index: currentTabIndex + 1, });
                } else {
                    // 普通点击：在当前标签页后面打开并切换过去
                    chrome.tabs.create({ url: searchUrl, active: true, index: currentTabIndex + 1, });
                }

            }); //tabs.query
        }

    }); //sendMessage


});

